var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _MouseHandler_instances, _MouseHandler_x, _MouseHandler_y, _MouseHandler_params, _MouseHandler_handleMouse;
class MouseHandler {
    constructor(params) {
        _MouseHandler_instances.add(this);
        _MouseHandler_x.set(this, void 0);
        _MouseHandler_y.set(this, void 0);
        _MouseHandler_params.set(this, void 0);
        __classPrivateFieldSet(this, _MouseHandler_params, params, "f");
    }
    mount() {
        if (__classPrivateFieldGet(this, _MouseHandler_params, "f").cursorMonitoring) {
            window.addEventListener('mousemove', __classPrivateFieldGet(this, _MouseHandler_instances, "m", _MouseHandler_handleMouse).bind(this));
        }
        window.addEventListener('click', __classPrivateFieldGet(this, _MouseHandler_params, "f").onClick);
    }
    unmount() {
        window.removeEventListener('mousemove', __classPrivateFieldGet(this, _MouseHandler_instances, "m", _MouseHandler_handleMouse).bind(this));
        window.removeEventListener('click', __classPrivateFieldGet(this, _MouseHandler_params, "f").onClick);
    }
}
_MouseHandler_x = new WeakMap(), _MouseHandler_y = new WeakMap(), _MouseHandler_params = new WeakMap(), _MouseHandler_instances = new WeakSet(), _MouseHandler_handleMouse = function _MouseHandler_handleMouse(event) {
    __classPrivateFieldSet(this, _MouseHandler_x, event.clientX, "f");
    __classPrivateFieldSet(this, _MouseHandler_y, event.clientY, "f");
    __classPrivateFieldGet(this, _MouseHandler_params, "f").onMove(__classPrivateFieldGet(this, _MouseHandler_x, "f"), __classPrivateFieldGet(this, _MouseHandler_y, "f"));
};
export default MouseHandler;
//# sourceMappingURL=MouseHandler.js.map